CREATE TABLE db (a INT PRIMARY KEY, b TEXT);

-- Beispiel einer PL/pgSQL Function. Um plpgsql in Postgres zu aktivieren
-- muss zuvor einmalig auf der Konsole "createlang plpgsql" ausgeführt werden.
-- Dies sollte bei Ihren Accounts bereits passiert sein.
CREATE FUNCTION merge_db(key INT, data TEXT) RETURNS VOID AS
$$
DECLARE
  aRecord RECORD;
BEGIN
-- LOOP über alle Zeilen einer Tabelle (mit Ausgabe zur Demonstration)
  FOR aRecord IN SELECT * FROM DB LOOP
    RAISE NOTICE 'Found key %',aRecord.a;
  END LOOP;

-- Der folgende Teil versucht ein Update auf eine Tabelle, falls dies
-- fehlschlägt (weil der key nicht in der Tabelle enthalten ist) wird
-- die Zeile eingefügt.
  UPDATE db SET b = data WHERE a = key;
  IF NOT found THEN
    INSERT INTO db(a,b) VALUES (key, data);
  END IF;

-- Beispiel von Exception-Handling, der Key wird verdoppelt und
-- versucht nocheinmal in die Tabelle einzufügen. Falls eine
-- Exception passiert (unique_violation) wird diese gesondert
-- behandelt und alles innerhalb des Blocks rückgängig gemacht.
  BEGIN
    INSERT INTO db(a,b) VALUES (2*key, data);
    RETURN;
  EXCEPTION WHEN unique_violation THEN
      -- do something.
      RAISE NOTICE 'EXCEPTION RAISED';
  END;
END;
$$
LANGUAGE plpgsql;
